=== doc/Makefile ===
##
## Makefile for Proof General doc directory.
##
## Author:  David Aspinall <da@dcs.ed.ac.uk>
##
## Maintainer:  Proof General maintainer <proofgen@dcs.ed.ac.uk>
##
## Makefile,v 7.0 2002/08/29 09:12:11 da Exp
## 
###########################################################################
##
## Use:
##	make info,dvi,pdf,html    - build respective docs from texi source.
##	make doc		  - make default kinds of doc (dvi, info).
##
###########################################################################

default:
	$(MAKE) doc

%:
	make -f Makefile.doc DOCNAME=PG-adapting MAKE="make -f Makefile.doc" $@
	make -f Makefile.doc DOCNAME=ProofGeneral MAKE="make -f Makefile.doc" $@
