=== doc/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 ##
 ## Maintainer:  Proof General maintainer <proofgen@dcs.ed.ac.uk>
 ##
-## Makefile,v 7.0 2002/08/29 09:12:11 da Exp
+## Makefile,v 8.0 2004/04/17 23:39:58 da Exp
 ## 
 ###########################################################################
 ##
@@ -22,3 +22,10 @@
 	make -f Makefile.doc DOCNAME=PG-adapting MAKE="make -f Makefile.doc" $@
 	make -f Makefile.doc DOCNAME=ProofGeneral MAKE="make -f Makefile.doc" $@ 
 
+##
+## man page for proofgeneral script
+##
+# man: proofgeneral.1
+#
+#proofgeneral.1: ../bin/proofgeneral
+#	help2man --output=$@  ../bin/proofgeneral
