## proofgeneral 3.7

=== Makefile ===
--- 
+++ 
@@ -4,18 +4,24 @@
 ## Author:  David Aspinall <David.Aspinall@ed.ac.uk>
 ##
 ##  make		- do "compile" and "scripts" targets
-##  make compile	- make .elc's in a single session
+##  make compile	- make .elc's 
 ##  make scripts	- edit paths to bash/perl/PGHOME in scripts
 ##  make install	- install into system directories
 ##  make clean		- return to clean source
 ##
-## Makefile,v 8.0 2004/04/17 23:23:53 da Exp
+## Edit the EMACS setting below or call with an explicit one, like this:
+##
+##     make EMACS=xemacs
+## or
+##     make EMACS=/Applications/Emacs.app/Contents/MacOS/Emacs
+##
+## Makefile,v 9.1 2008/01/31 13:06:38 da Exp
 ## 
 ###########################################################################
 
 # Set this to "emacs" or "xemacs" according to your version of Emacs.
 # NB: this is also used to set default install path names below.
-EMACS=xemacs
+EMACS=$(shell if [ -z "`which emacs`" ]; then echo xemacs; else echo emacs; fi)
 
 # We default to /usr rather than /usr/local because installs of
 # desktop and doc files under /usr/local are unlikely to work with
@@ -28,70 +34,80 @@
 
 PWD=$(shell pwd)
 
-ELISP_DIRS = acl2 coq demoisa generic hol98 isa isar lclam lego mmm phox plastic twelf
+PROVERS=acl2 ccc coq demoisa hol98 isar lclam lego pgshell phox plastic twelf
+OTHER_ELISP=generic lib mmm
+ELISP_DIRS=${PROVERS} ${OTHER_ELISP}
+ELISP_EXTRAS=isar/interface isar/isartags
 EXTRA_DIRS = images x-symbol
 
-BATCHEMACS=${EMACS} -batch -q -no-site-file
-
-BASH_SCRIPTS = isa/interface isar/interface bin/proofgeneral
-PERL_SCRIPTS = lego/legotags coq/coqtags
-BIN_SCRIPTS = bin/proofgeneral
+DOC_FILES=AUTHORS BUGS COMPATIBILITY CHANGES COPYING INSTALL README REGISTER doc/*.pdf
+DOC_EXAMPLES=acl2/*.acl2 hol98/*.sml isar/*.thy lclam/*.lcm lego/*.l pgshell/*.pgsh phox/*.phx plastic/*.lf twelf/*.elf
+DOC_SUBDIRS=${DOC_EXAMPLES} */README* */CHANGES */BUGS 
+
+BATCHEMACS=${EMACS} --batch --no-site-file -q 
+
+# Scripts to edit paths to shells
+BASH_SCRIPTS = isar/interface bin/proofgeneral
+PERL_SCRIPTS = lego/legotags coq/coqtags isar/isartags
+# Scripts to edit path to PG
 PG_SCRIPTS = bin/proofgeneral
 
-# FIXME: would rather set load path in Elisp,
-# but seems tricky to do only during compilation.
-# Another idea: put a function in proof-site to
-# output the compile-time load path and
-# ELISP_DIRS so these are set just in that one
-# place.
+# Scripts to install to bin directory
+BIN_SCRIPTS = bin/proofgeneral lego/legotags coq/coqtags isar/isartags
+
+# Setting load path might be better in Elisp, but seems tricky to do
+# only during compilation.  Another idea: put a function in proof-site
+# to output the compile-time load path and ELISP_DIRS so these are set
+# just in that one place.
 BYTECOMP = $(BATCHEMACS) -eval '(setq load-path (append (mapcar (lambda (d) (concat "${PWD}/" (symbol-name d))) (quote (${ELISP_DIRS}))) load-path))' -f batch-byte-compile
 EL=$(shell for f in $(ELISP_DIRS); do ls $$f/*.el; done)
 ELC=$(EL:.el=.elc)
 
-# Some parts of code were not compile safe, because of macros
-# being expanded too early (e.g. proof-defshortcut, easy-menu-define)
-# This should be fixed for 3.5, although careful testing is required.
-BROKENELC=
-
 .SUFFIXES:	.el .elc
 
 default: all
 
+FORCE:
+
 ## 
-## compile : byte compile files in working directory:
-##           Clearout old .elc's and re-compile in a
-##           single Emacs process.  This is faster than "make elc",
-##	     but can have artefacts because of context between
-##	     compiles.
-##
-compile: .byte-compile
-	lastemacs=`cat .byte-compile`; if [ "$$lastemacs" != "$(EMACS)" ]; then rm -f .byte-compile; make .byte-compile; fi
-
+## compile : byte compile all lisp files
+##           If EMACS variable has changed since last call, clearout 
+##	     old .elc's and re-compile.
+##
+compile: $(EL) x-symbol/lisp/*.el
+	lastemacs=`cat .byte-compile 2>/dev/null || echo `; if [ "$$lastemacs" != "" ] && [ "$$lastemacs" != "$(EMACS)" ]; then rm -f .byte-compile $(ELC) x-symbol/lisp/*.elc; fi
+	make .byte-compile
+
+## Compiling can show up errors in the code, but be wary of fixing obsoletion
+## or argument call warnings unless they're valid for both Emacsen.
 
 .byte-compile: $(EL) x-symbol/lisp/*.el
-	@echo "*************************************************"
-	@echo " Byte compiling..."
-	@echo "*************************************************"
-	rm -f $(ELC) 
-## ignore errors for now: some files still have probs [x-symbol induced]
-	-$(BYTECOMP) $(EL)
-	rm -f $(BROKENELC)
+	@echo "****************************************************************"
+	@echo " Byte compiling... "
+	@echo "****************************************************************"
+	make elc
 	@echo " Byte compiling X-Symbol..."
-	(cd x-symbol/lisp; rm -f *.elc; $(MAKE) EMACS="$(EMACS) -q -no-site-file")
+	(cd x-symbol/lisp; $(MAKE) EMACS="$(EMACS) -q -no-site-file")
 	echo $(EMACS) > $(@)
-	@echo "*************************************************"
+	@echo "****************************************************************"
 	@echo " Finished."
-	@echo "*************************************************"
-
-
-##
-## Make .elc's individually.  For testing only: it's a nuisance to
-## set compiling context properly in each .el file.
-##
+	@echo "****************************************************************"
+
+
+##
+## Make an individual .elc.  Building separately means we need to be
+## careful to add proper requires in source files and prevent
+## evaluating/optimising top-level forms too early.  Using a separate
+## emacs process for each file is slower but avoids any chance of
+## accidently polluting the compilation environment.
+##
+
+## maths-menu.el doesn't compile on XEmacs 21.4, argh.
+lib/maths-menu.elc: lib/maths-menu.el
+	-$(BYTECOMP) $*.el
 
 .el.elc:
 	$(BYTECOMP) $*.el
-	rm -f $(BROKENELC)
 
 elc:	$(ELC)
 
@@ -99,8 +115,6 @@
 ##
 ## Default targets
 ##
-
-default: compile scripts
 
 all:	compile scripts
 
@@ -138,7 +152,7 @@
 DESKTOP=${PREFIX}/share
 DOCDIR=${PREFIX}/share/doc/ProofGeneral
 MANDIR=${PREFIX}/share/man/man1
-INFODIR=${PREFIX}/share/info/
+INFODIR=${PREFIX}/share/info
 
 install: install-desktop install-elisp install-bin install-init
 
@@ -156,6 +170,7 @@
 	mkdir -p ${DESKTOP}/mime-info
 	cp etc/desktop/mime-info/proofgeneral.mime ${DESKTOP}/mime-info
 	cp etc/desktop/mime-info/proofgeneral.keys ${DESKTOP}/mime-info
+# backwards compatibility with old linuxes
 	mkdir -p ${DESKTOP}/application-registry
 	cp etc/desktop/application-registry/proofgeneral.applications ${DESKTOP}/application-registry
 
@@ -169,17 +184,21 @@
 # FIXME 2: should deal with x-symbol properly and avoid duplication
 # with images, and also to avoid including .elc and .el files in
 # x-symbol subdirectory.
+# FIMXE 3: Michaël Cadilhac pointed out that 'cp -p' when used with
+# sudo to install will give users ownership instead of root. 
+# Should use install program or fix ownerships afterwards here.
 install-el:
 	mkdir -p ${ELISP}
 	for f in ${ELISP_DIRS} ${EXTRA_DIRS}; do mkdir -p ${ELISP}/$$f; done
 	for f in ${ELISP_DIRS}; do cp -pf $$f/*.el ${ELISP}/$$f; done
 	for f in ${EXTRA_DIRS}; do cp -prf $$f/* ${ELISP}/$$f; done
+	for f in ${ELISP_EXTRAS}; do cp -pf $$f ${ELISP}/$$f; done
 
 install-elc: compile
 	mkdir -p ${ELISP}
 	for f in ${ELISP_DIRS} ${EXTRA_DIRS}; do mkdir -p ${ELISP}/$$f; done
 	for f in ${ELISP_DIRS}; do cp -pf $$f/*.elc ${ELISP}/$$f; done
-	for f in ${EXTRA_DIRS}; do cp -prf $$f/* ${ELISP}/$$f; done
+	for f in ${ELISP_EXTRAS}; do cp -pf $$f ${ELISP}/$$f; done
 
 install-init:
 	mkdir -p ${ELISP_START}
@@ -191,16 +210,22 @@
 	mkdir -p ${BINDIR}
 	cp -pf ${BIN_SCRIPTS} ${BINDIR}
 
-install-doc: doc.info
+install-doc: doc.info doc.pdf
 	mkdir -p ${MANDIR}
 	cp -pf doc/proofgeneral.1 ${MANDIR}
 	mkdir -p ${INFODIR}
 	cp -pf doc/*.info ${INFODIR}
 	/sbin/install-info ${INFODIR}/ProofGeneral.info* ${INFODIR}/dir
 	/sbin/install-info ${INFODIR}/PG-adapting.info* ${INFODIR}/dir
-
-doc.%: 
-	(cd doc; make $*)
+	mkdir -p ${DOCDIR}
+	for f in ${DOC_FILES}; do cp -pf $$f ${DOCDIR}; done
+	for f in ${DOC_EXAMPLES}; do mkdir -p ${DOCDIR}/`dirname $$f`; cp -pf $$f ${DOCDIR}/$$f; done
+
+doc: FORCE
+	(cd doc; make EMACS=$(EMACS) $*)
+
+doc.%: FORCE
+	(cd doc; make EMACS=$(EMACS) $*)
 
 ##
 ## scripts: try to patch bash and perl scripts with correct paths
@@ -234,30 +259,22 @@
 # FIXME: this next edit is really for install case, shouldn't be made
 # just when user types 'make'
 pgscripts:
-	@(pghome=${DEST_ELISP}; \
-	 for i in $(PG_SCRIPTS); do \
-	   sed "s|PGHOME=.*$$|PGHOME=$$pghome|" < $$i > .tmp \
+	@(for i in $(PG_SCRIPTS); do \
+	   sed "s|PGHOMEDEFAULT=.*$$|PGHOMEDEFAULT=${DEST_ELISP}|" < $$i > .tmp \
 	   && cat .tmp > $$i; \
 	 done; \
 	 rm -f .tmp)
 
 # Set PGHOME path in scripts back to default location.
 cleanpgscripts:
-	make pgscripts DEST_ELISP='$$$$HOME/ProofGeneral'
-
-
-##
-## This special target lets us use targets defined 
-## in developer's makefile Makefile.devel conveniently,
-## via make devel.<target>
-##
-
-devel.%:
-	make -f Makefile.devel $*
-
-##
-## Similarly for xemacs Makefile.
-##
-
-xemacs.%:
-	make -f Makefile.xemacs $*
+	@(for i in $(PG_SCRIPTS); do \
+	   sed "s|PGHOMEDEFAULT=.*$$|PGHOMEDEFAULT=\$$HOME/ProofGeneral|" < $$i > .tmp \
+	   && cat .tmp > $$i; \
+	 done; \
+	 rm -f .tmp)
+
+##
+## Include developer's makefile if it exists here.
+##
+
+-include Makefile.devel
