=== x-symbol/lisp/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Makefile for emacs-lisp package
 
-#ident "@(#)Makefile  $:Makefile,v 8.0 2004/04/17 23:40:01 da Exp"
+#ident "@(#)Makefile  $:Makefile,v 9.0 2008/01/30 15:22:26 da Exp"
 
 # Copyright (C) 1998-1999  Stefan Monnier <monnier@cs.yale.edu>
