## proofgeneral 4.2~pre120112

=== debian/changelog ===
proofgeneral (4.2~pre120112-1) unstable; urgency=low

  * adopting proofgeneral (Closes: #554263)
  * restart packaging from scratch (Closes: #626589)
    This new Proof General package has not much in common with the old
    one:
    - source package format 3.0 (quilt)
    - only two binary packages: proofgeneral and proofgeneral-doc
    - no support for Isabelle/Hol or Isar, because Isabelle is packaged
      with its own custom version of Proof General (Closes: #252721)
    - no support for minlog because it is not present upstream 
      (Closes: #613779)
    - support only Coq and PhoX
    - no debconf, proofgeneral is always installed site-wide (Closes: #452824)
    - only support emacs23, because upstream only supports emacs23
      (Closes: #520566)
    The old changelog file is appended below.

 -- Hendrik Tews <hendrik@askra.de>  Thu, 12 Jan 2012 21:15:51 +0100

proofgeneral (3.7-4) unstable; urgency=low

  * QA upload
  * Use Debian QQA as maintainer. Closes: #554263
  * Danish debconf translation update. Closes: #592274

 -- Christian Perrier <bubulle@debian.org>  Mon, 11 Oct 2010 21:47:36 +0200

proofgeneral (3.7-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Trivial lintian fixes:
    - Add ${misc:Depends} to binary packages dependencies
      so that debhelper-triggered dependencies are properly
      added at build time.
    - Bump debhelper compatibility to 7
    - Replace calls to deprecated "dh_clean -k" by dh_prep
    - Have copyright file refer to the versioned GPL-2
      license file
    - Drop calls to install-info to register info pages as
      this is now handled by triggers
    - As a consequence, drop the now empty proofgeneral.prerm
      script
    - No longer ignore errors in proofgeneral.postinst,
       proofgeneral.presinst and proofgeneral.config (use "set -e")
    - Add dependency on "dpkg (>= 1.15.4) | install-info"
      to properly ihandle info documents installation
  * Fix pending l10n issues. Debconf translations:
    - Swedish (Martin Bagge).  Closes: #504034
    - Japanese (Hideki Yamane (Debian-JP)).  Closes: #510721
    - Spanish (Fernando González de Requena).  Closes: #520539
    - Italian (Luca Monducci).  Closes: #546648

 -- Christian Perrier <bubulle@debian.org>  Sat, 19 Sep 2009 07:47:14 +0200

proofgeneral (3.7-3) unstable; urgency=low

  * Fix bin/proofgeneral script:
    - correct lowercase path to the lisp directory. Closes: 473893
    - working -v and --version option which need the PGHOME to work.

 -- Stefan Schimanski <schimmi@debian.org>  Wed, 2 Apr 2008 11:41:10 +0100

proofgeneral (3.7-2) unstable; urgency=low

  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. Closes: #450681
  * [Debconf translation updates]
    - Galician. Closes: #451163
    - Portuguese. Closes: #451170
    - Finnish. Closes: #451280
    - German. Closes: #451761
    - Czech. Closes: #451832
    - French. Closes: #452809
    - Dutch. Closes: #452951
    - Russian. Closes: #453317
    - Vietnamese. Closes: #453650
  * [Lintian] Insert correct copyright in debian/copyright

 -- Stefan Schimanski <schimmi@debian.org>  Wed, 19 Mar 2008 19:25:44 +0200

proofgeneral (3.5-6) unstable; urgency=low

  * Removed support for mzscheme <300
  * Only use one startup script for all emacs versions
  * Added nl translation. Closes: 418390
  * Moved to menu section Applications/Science/Mathematics

 -- Stefan Schimanski <schimmi@debian.org>  Sun, 21 Oct 2007 17:36:26 +0200

proofgeneral (3.5-5) unstable; urgency=low

  * Fix emacs dependencies. Emacs22 is current now in sid. Closes: 434975, 403147

 -- Stefan Schimanski <schimmi@debian.org>  Sun, 07 Oct 2007 23:03:21 +0200

proofgeneral (3.5-4.1) unstable; urgency=low

  * Non-maintainer upload to fix an RC bug
  * Move debhelper and mzscheme to Build-Depends. Closes: 403572
    Lintian warnings are things that should be taken seriously.
  * Lintian fixes:
    - Remove useless CVS directory minlog/CVS
    - Use 4 as debhelper compatibility (through debian/compat)  

 -- Christian Perrier <bubulle@debian.org>  Tue, 19 Dec 2006 08:27:28 +0100

proofgeneral (3.5-4) unstable; urgency=low

  * Added support for Minlog
  * Do not load proof-site.el automatically anymore, but instead 
    install an interactive function "proofgeneral". It then loads
    the ProofGeneral and, most importantly, assign the file extension
    to ProofGeneral. Closes: #260074,#176921
  
 -- Stefan Schimanski <schimmi@debian.org>  Wed, 6 Dec 2006 21:47:30 +0200
  

proofgeneral (3.5-3.1) unstable; urgency=low

  * Non maintainer upload to fix longstanding l10n issues
  * Add debconf-2.0 as alternative to debconf. Closes: #332077
  * Debconf templates translations:
    - Added Vietnamese. Closes: #317611
    - Added Japasese. Closes: #288029
    - Added Czech. Closes: #308466
    - Added Swedish. Closes: #332359
    - Added Brazilian Portuguese. Sent during the call for updates of the NMU.
    - Added Russian. Sent during the call for updates of the NMU.
    - Added Portuguese. Sent during the call for updates of the NMU.
    - Added German. Sent during the call for updates of the NMU.

 -- Christian Perrier <bubulle@debian.org>  Sat,  7 Oct 2006 00:33:05 +0200

proofgeneral (3.5-3) unstable; urgency=low

  * Updated maintainer email address.

 -- Stefan Schimanski <schimmi@debian.org>  Fri, 20 Aug 2004 14:38:30 +0200

proofgeneral (3.5-2) unstable; urgency=low

  * Fixed info path (closes: #215126)
  * Fixed typos (closes: #239005)
  * Fixed url to ProofGeneral homepage (closes: #262636)
  * This is 3.5 (closes #247854)
  * Load ~/.proofgeneral if available from proofgeneral script (closes #252252)

 -- Stefan Schimanski <schimmi@debian.org>  Fri, 20 Aug 2004 14:18:46 +0200

proofgeneral (3.5-1) unstable; urgency=low

  * New upstream release.

 -- Stefan Schimanski <schimmi@debian.org>  Mon, 20 Aug 2004 13:40:30 +0200

proofgeneral (3.4-14) unstable; urgency=low


