=== debian/control ===
Source: proofgeneral
Section: science
Priority: optional
Maintainer: Hendrik Tews <hendrik@askra.de>
Build-Depends: debhelper (>= 8), texinfo, texlive-latex-base, texlive-generic-recommended, texi2html, emacs23-nox | emacs23 | emacs23-lucid
Standards-Version: 3.9.2
Homepage: http://proofgeneral.inf.ed.ac.uk

Package: proofgeneral
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, emacs23 | emacs23-nox | emacs23-lucid, mmm-mode
Suggests: proofgeneral-doc
Replaces: proofgeneral-coq, proofgeneral-misc
Conflicts: proofgeneral-coq, proofgeneral-minlog, proofgeneral-misc
Description: generic frontend for proof assistants
 Proof General is a major mode to turn Emacs into an interactive proof
 assistant to write formal mathematical proofs using a variety of
 theorem provers. 
 .
 This package provides the Proof General support for Coq, PhoX and LEGO.


Package: proofgeneral-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: info-browser | pdf-viewer | www-browser
Suggests: proofgeneral
Description: generic frontend for proof assistants - documentation
 Proof General is a major mode to turn Emacs into an interactive proof
 assistant to write formal mathematical proofs using a variety of
 theorem provers. 
 .
 This package provides Proof General user manual in info, html and pdf
 form.
